// MainView.cpp : implementation of the CMainView class
//

#include "stdafx.h"
#include "Parser.h"

#include "Doc.h"
#include "MainView.h"
#include "mainfrm.h"
#include "utility.h"
#include "parseit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainView

IMPLEMENT_DYNCREATE(CMainView, CFormView)

BEGIN_MESSAGE_MAP(CMainView, CFormView)
	//{{AFX_MSG_MAP(CMainView)
	ON_BN_CLICKED(IDC_BTNPARSE, OnBtnparse)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainView construction/destruction

CMainView::CMainView()
	: CFormView(CMainView::IDD)
{
	//{{AFX_DATA_INIT(CMainView)
	m_Data = _T("1and a @2 and a @3 and a@4anda#5 anda #6 anda@7");
	m_Seperator = _T("#@");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CMainView::~CMainView()
{
}

void CMainView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainView)
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Text(pDX, IDC_THEDATA, m_Data);
	DDX_Text(pDX, IDC_THESEPERATOR, m_Seperator);
	DDV_MaxChars(pDX, m_Seperator, 8);
	//}}AFX_DATA_MAP
}

BOOL CMainView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainView diagnostics

#ifdef _DEBUG
void CMainView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMainView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDoc* CMainView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDoc)));
	return (CDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Virtual Function Overrides

void CMainView::OnInitialUpdate() 
{
	static	BOOL FirstTime=TRUE;
    CMainFrame* pFrame;
    CRect rectFrame, rectView;

    CFormView::OnInitialUpdate();
	UpdateData(FALSE);

	if(FirstTime==TRUE)
	{
			FirstTime=FALSE;
		// Resize parent to fit dialog template exactly    
		// while not resizing beyond size of screen
		VERIFY( pFrame = (CMainFrame*)GetParentFrame() );
		pFrame->GetClientRect( rectFrame );
		GetClientRect( rectView );
		if ( rectFrame.Width() > rectView.Width()
			 || rectFrame.Height() < rectView.Height() )
		{        
			// Resize so can be refit to any template that fits the screen
			pFrame->MoveWindow( 0, 0, GetSystemMetrics(SM_CXSCREEN), 
							GetSystemMetrics(SM_CYSCREEN), FALSE ); 
		}
		pFrame->RecalcLayout();
		ResizeParentToFit(TRUE);    // Shrink to fit template
		pFrame->CenterWindow();
	}		
	InitList();
}

void CMainView::OnPaint() 
{
	CPaintDC(this);
	CMainFrame* pFrame=(CMainFrame*)GetParentFrame();
	pFrame->SetWindowText("Parse Class Demo");
}

/////////////////////////////////////////////////////////////////////////////
// CList control handlers

void CMainView::InitList()
{
	int Offset;
	LV_ITEM*	pItem=new LV_ITEM;
	m_List.DeleteAllItems();
	int nIndex=m_List.DeleteColumn(0);
	while(nIndex)
		nIndex=m_List.DeleteColumn(0);		
	m_List.SetBkColor(COLOR_YELLOW);
	m_List.SetTextBkColor(COLOR_YELLOW);
	RECT	rect;
	m_List.GetClientRect(&rect);
	Offset=rect.right/6;
	m_List.InsertColumn(0,"Field #",LVCFMT_LEFT,Offset,-1);
	m_List.InsertColumn(1,"Data",LVCFMT_LEFT,(Offset*5)-20,1);
	delete pItem;
}

LPSTR Istr(int num)
{
	static	char buff[7];
	sprintf(buff,"%d",num);
	return buff;
}


void CMainView::AddItemToList(int ndx,LPCSTR data)
{
	LV_ITEM*	pItem=new LV_ITEM;
	int	insAt;

	pItem->mask=LVIF_PARAM|LVIF_TEXT;
	pItem->iItem=0;
	pItem->iSubItem=0;
	pItem->pszText=Istr(ndx);
	insAt=m_List.InsertItem(pItem);
	m_List.SetItemText(insAt, 1, data);
	delete pItem;
}

/////////////////////////////////////////////////////////////////////////////
// Message handlers

void CMainView::OnBtnparse() 
{
	CParseIt	parser;						//	create a parser object
	CString		TheData;					// place to put field data into
	UpdateData();							//	Get it current
	if(!parser.Parse(m_Data,m_Seperator))   // this does all the work 
		return;								//	if here null string passed
	InitList();								//	empty current data from list ctrl
	for ( int y=0; y < parser.GetNumFields();++y) //  loop thru getting all the data
	{
		parser.GetField(y+1,TheData);
		AddItemToList(y+1,TheData);			//	add it to the list
	}
}

