#pragma once
//	RWS                   
#ifdef _DEBUG
#define	new DEBUG_NEW
#endif

///////////////////////////////////////////////////////////////////////////////////	
//	class definition for the ParseField class
///////////////////////////////////////////////////////////////////////////////////
//	this class is just a CString with some assignment and cast operators
//	it is used to store a parsed field value and allow the data to be accessed
//	thru casting the result to the wanted datatype
// This can be extended to cover any type of data including structures etc
//	************************** ALLOWED OPERATIONS *********************************
//	CParseField p;
//	p="1234.12" 		// assignment to LPCSTR
//	CStrinf e=(LPCSTR)p;//	operator (LPCSTR)
//	double d=(double)p;	//	d=1234.12 	operator double 
//	int n=(int)p;		//	n=1234 	operator int
//	long n=(long)p;		//	n=1234 	operator long
//////////////////////////////////////////////////////////////////////////////////
class CParseField{
public:
	CParseField() {};
	~CParseField() {};

	virtual operator int() 		{ return atoi(TheData);}; 
	virtual	operator long()		{ return atol(TheData);}; 
	virtual	operator double()	{ return atof(TheData);};
	virtual	operator LPCSTR()	{ return (LPCSTR) TheData;}; const
	virtual	CParseField& operator =(LPCSTR s) {TheData=s;return *this;};
	virtual	CParseField&  operator =(CString& s) {TheData=s;return *this;};
	virtual	CParseField&  operator =(CParseField& s) {TheData=s.TheData;return *this;};
	
// Implementation
protected:
	CString	TheData;
};
///////////////////////////////////////////////////////////////////////////////////
//	END OF CparseField DEFINITION AND CODE ( ALL FUNCTIONS HERE)
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////	
//	class definition for the Parsing class
///////////////////////////////////////////////////////////////////////////////////
class CParseIt
{
public:
	CParseIt();								//	default constructer
	CParseIt(LPCSTR Data,LPCSTR Sep=",");	//	paramatized constructor
	virtual	~CParseIt();					//	destructor

// Operations             
protected:           
	virtual	BOOL 		IsSeperator(char s);
	virtual	BOOL 		LoadFile(LPCSTR lpzFileName);
public:         
	virtual	void		Clear();
	virtual	BOOL	ParseFile(LPCSTR lpzFileName,LPCSTR Sep=",");
	//	returns the one based number of fields if 0 there are no fields
	virtual	int			GetNumFields() {return NumFields;};
	//	returns the list of seperators
	virtual	LPCSTR		GetSeperator() {return Seperator;};
	//	sets the seperator list IE "|,*"
	virtual	void		SetSeperator(LPCSTR Sep) {strncpy(Seperator,Sep,9);};
	//	parse a object constructed bt the second constructor (data,sep);
	virtual	BOOL		Parse();
	//	parse a object created by the default constructor will call Parse();
	virtual	BOOL		Parse(LPCSTR Data,LPCSTR Sep=",");
	//	returns the field in a reference variable of type passed
	virtual	BOOL	 	GetField(int nFNum,CString& Buff);
	virtual	BOOL	 	GetField(int nFNum,LPSTR Buff);
	virtual	BOOL		GetField(int N,double& dbl);
	virtual	BOOL		GetField(int N,int& intr);
	virtual	BOOL		GetField(int N,long& lng);
	//	will return the cparsefield object. This can be cast to the desired type
	//	by (int) (long) (double) (lpcstr)
	virtual	CParseField	GetField(int n);
	
// Implementation
protected:
	int			NumFields;
	char		Seperator[10];
	CPtrArray	TheFields;	
	LPSTR		TheData;
	
};
